/*
 *  Copyright (C) 2001 Kawamata/Hitoshi <hitoshi.kawamata@nifty.ne.jp>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "yuvfilters.h"

YfFrame_t *
YfInitFrame(YfFrame_t *frame, const YfTaskCore_t *h0)
{
  if (!frame) {
    if (!(frame = malloc(FRAMEBYTES(y4m_si_get_chroma(&h0->si), h0->width, h0->height)))) {
      mjpeg_error("malloc");
      return NULL;
    }
  }
  y4m_init_frame_info(&frame->fi);
  return frame;
}

void
YfFiniFrame(YfFrame_t *frame)
{
  y4m_fini_frame_info(&frame->fi);
}
